


###  simulating clstered data, with n independent cluster of size m and p covariates
####Normal with exchangeable covariance matrix
library(mvtnorm)

set.seed(183455)
m         <-    4        #{4,10}
p	        <-	  10       #{10, 20}
rhox      <-	  0       # {0, 0.2, 0.5}
n	        <-	  200   
B	        <-	  1000 

#true_beta <-   rep(0,p)
#true_beta <-   c(0,0,0,0.032,rep(0,(p-4)))
true_beta  <-   c(0,0.008,0.01,-0.03,0.005, -0.01,rep(0,(p-6)))

sM   <-  rep(0,B)
sB   <-  rep(0,B)
sT   <-  rep(0,B)
sD   <-  rep(0,B)
sH   <-  rep(0,B)
sS   <-  rep(0,B)
sN   <-  rep(0,B)

Mm   <-  rep(0,B)
Bb   <-  rep(0,B)
Tt   <-  rep(0,B)
Dd   <-  rep(0,B)
Hh   <-  rep(0,B)
Ss   <-  rep(0,B)
Nn   <-  rep(0,B)



if (p==10){
  C <- rbind(c(-1, 1, rep(0,8)),
             c(-1, 0, 1,rep(0,7)),
             c(-1, 0, 0, 1,rep(0,6)),
             c(-1, 0, 0, 0, 1,rep(0,5)),
             c(-1, 0, 0, 0, 0, 1,rep(0,4)),
             c(-1, 0, 0, 0, 0, 0, 1,rep(0,3)),
             c(-1, 0, 0, 0, 0, 0, 0, 1,rep(0,2)),
             c(-1, rep(0,7), 1, 0),
             c(-1, rep(0,8), 1))
  
}else if (p==20){
  
  C <- rbind(c(-1, 1, rep(0,18)),
             c(-1, 0, 1,rep(0,17)),
             c(-1, 0, 0, 1,rep(0,16)),
             c(-1, 0, 0, 0, 1,rep(0,15)),
             c(-1, 0, 0, 0, 0, 1,rep(0,14)),
             c(-1, 0, 0, 0, 0, 0, 1,rep(0,13)),
             c(-1, 0, 0, 0, 0, 0, 0, 1,rep(0,12)),
             c(-1, rep(0,7), 1, rep(0,11)),
             c(-1, rep(0,8), 1, rep(0,10)),
             c(-1, rep(0,9), 1, rep(0,9)),
             c(-1, rep(0,10), 1, rep(0,8)),
             c(-1, rep(0,11), 1, rep(0,7)),
             c(-1, rep(0,12), 1, rep(0,6)),
             c(-1, rep(0,13), 1, rep(0,5)),
             c(-1, rep(0,14), 1, rep(0,4)),
             c(-1, rep(0,15), 1, rep(0,3)),
             c(-1, rep(0,16), 1, rep(0,2)),
             c(-1, rep(0,17), 1, 0),
             c(-1, rep(0,18), 1))
}

C     <-    t(C)

#C   	  <- 	 matrix(0,nrow=p,ncol=p*(p-1)/2)
#comb 	<- 	 combn(p,2)
#C[cbind(comb[1,],1:(p*(p-1)/2))] <- 1
#C[cbind(comb[2,],1:(p*(p-1)/2))] <- -1




seed   <-  sample(seq(1111111,99956999,24),B)

###	 building an exchangeable covariance matrix

sigx	      <-   	array(rep(rhox,m^2),dim=c(m,m))     
sigx	      <-   	sigx+(1-rhox)*diag(m)
sigma2	    <-   	0.8
sigma_true	<-   	sigma2 *sigx


###	Monte Carlo simulation to approximate familywise type I error and power

for(b in 1:B){
  set.seed(seed[b])
  desx      <-  	array(dim=c(m,p,n))
  y         <-  	matrix(0,nrow=m,ncol=n)
  mu        <-  	array(dim=c(m,1,n))
  
  ###		Generating n independent clusters from m-variate normal
  
  for (k in 1:n){
    
    for(j in 1:p){
      l          <-   sample(seq(-3,3,0.5),1)
      v          <-   sample(seq(3,6,0.6),1)
      desx[,j,k] <-   rnorm(m,l,v)
    }
    
    mu[,,k]      <-   desx[,,k] %*% true_beta
    y[,k]        <-   mvrnorm(1,mu[,,k], sigma_true, tol = 1e-6, empirical = FALSE)
  }
  
  ###		Estimating beta and sigma from marginal normal log likelihood
  
  beta_hat   <- 	rep(0,p)
  sum1       <- 	matrix(0,nrow=p, ncol=p)
  sum2       <- 	rep(0,p)
  yy         <- 	rep(0,n*m)
  
  for( i in 1:(n)){
    yy[((i-1)*m+1):(i*m)]	 <- 	y[,i]
  }
  
  xx       <- 	matrix(0,nrow=m*n, ncol=p)
  data     <- 	data.frame(xx,yy)
  
  for( i in 1:(n)){
    xx[((i-1)*m+1):(i*m),] 	<- 	desx[,,i]
  }
  
  sum1     <- 	t(xx)%*%xx
  sum2     <- 	t(xx)%*%yy
  beta_hat <- 	solve(sum1)%*%sum2  
  
  
  
  yhat      <- 	matrix(0,nrow=m,ncol=n)
  e         <- 	matrix(0,nrow=m,ncol=n)
  sigma_hat <- 	matrix(0,nrow=m,ncol=m)
  error_mat <- 	matrix(0,nrow=m,ncol=m)
  
  for ( i in 1:n){
    yhat[,i] 	<- 	desx[,,i] %*% beta_hat
    e[,i]    	<- 	y[,i]-yhat[,i]                          	
  }
  sii   	<- 	sum(apply(e,1,function(x)sum(x^2)))/(n*m-p)	
  
  E         <- 	rep(0,n)
  for (i in 1:n){
    for( j in 1:(m-1)){
      E[i] 	<- 	E[i] + sum(e[j,i]*e[(j+1):m,i])
    }  
  }
  r 		<- 	sum(E)/((n-p)*choose(m,2)*sii)
  
  Sigma_hat  <- 	array(rep(r,m^2),dim=c(m,m))
  Sigma_hat  <- 	Sigma_hat+ (1-r)*diag(m)
  Sigma_hat  <- 	sii*Sigma_hat 		                   # estimated covariance matrix
  
  ###  	computing covariance of coefficients
  
  c1		<-	matrix(0,nrow=p,ncol=p)
  c2		<- 	matrix(0,nrow=p,ncol=p)
  
  for(i in 1:n){
    c1	<-	c1 +(t(desx[,,i])%*%desx[,,i])
    c2	<-	c2 +t(desx[,,i])%*%Sigma_hat%*%desx[,,i]
  }
  
  Cov_beta  <- 	solve(c1)%*%c2 %*%t(solve(c1)) 
  
  
  
  ###	computing test statistics based on composite likelihood results
  
  
  bstr     	<- 	 t(C)%*%beta_hat
  cov_str 	<- 	 t(C)%*%Cov_beta%*%C
  se_str 	  <- 	 diag(cov_str)^(-1/2)
  v_mat    	<- 	 diag(se_str)  
  
  T 		    <-	 bstr*se_str
  cov_T 	  <- 	 v_mat%*%cov_str%*%t(v_mat)  
  

  ###	computing the m-variate normal quantile to consider it as threshold and performing hypothesis test	
  
  qu 	    	<- 	 qmvnorm(0.95, tail ="both.tails", mean = 0,  corr=cov_T)
  quantile  <- 	 qu$quantile
  sM[b] 	  <- 	 sum(abs(T)<quantile)
  Mm[b]     <-   as.numeric(abs(T)[3,]<quantile)
  #Mm[b]    <-   as.numeric(abs(T)[1,]<quantile)+ as.numeric(abs(T)[2,]<quantile)+ as.numeric(abs(T)[3,]<quantile)+ as.numeric(abs(T)[4,]<quantile)+ as.numeric(abs(T)[5,]<quantile)
  
  ###	Bonferroni  
  
  Bon 	    <- 	0.05/ncol(C)
  qBon 	    <- 	qnorm(1-Bon/2)  
  sB[b]     <-  sum(abs(T)<qBon)                      #FWER
  Bb[b]     <-  as.numeric(abs(T)[3,]<qBon)           #Power with the fist alternative
  #Bb[b]    <-  as.numeric(abs(T)[1,]<qBon)+ as.numeric(abs(T)[2,]<qBon)+ as.numeric(abs(T)[3,]<qBon)+ as.numeric(abs(T)[4,]<qBon)+ as.numeric(abs(T)[5,]<qBon)   #Power with the second alternative
  
  ###	Dunn-Sidak
  
  dunn 		 <- 	1-(1-0.05)^(1/ncol(C))
  qDunn 	 <- 	qnorm(1-dunn/2)  
  sD[b]    <-   sum(abs(T)<qDunn)
  Dd[b]    <-   as.numeric(abs(T)[3,]<qDunn) 
  Dd[b]    <-   as.numeric(abs(T)[1,]<qDunn)+ as.numeric(abs(T)[2,]<qDunn)+ as.numeric(abs(T)[3,]<qDunn)+ as.numeric(abs(T)[4,]<qDunn)+ as.numeric(abs(T)[5,]<qDunn)
  
  ###	Holm
  
  t_h   	 <- 	sort(abs(T),decreasing=TRUE)
  Holm 		 <- 	0.05/(ncol(C)-c(1:ncol(C))+1)
  qHolm 	 <- 	qnorm(1-Holm/2) 
  
  ind1     <-   t_h< qHolm 
  sH[b]    <-   as.numeric(ind1[1]==FALSE)
#   for ( i in 1:5){
#
#     if (ind1[i]==FALSE){
#       Hh[b]    <- Hh[b] +1
#
#       if (ind1[(i+1)]==TRUE){
#         break}
#     }
#   }


  ### Scheffe
  qscheffe  <-  sqrt(qchisq(0.95,(p-1)))  
  sS[b]     <-  sum(abs(T)< qscheffe )
  Ss[b]     <-  as.numeric(abs(T)[3,]<qscheffe)
  #Ss[b]    <-  as.numeric(abs(T)[1,]<qscheffe)+ as.numeric(abs(T)[2,]<qscheffe)+ as.numeric(abs(T)[3,]<qscheffe)+ as.numeric(abs(T)[4,]<qscheffe)+ as.numeric(abs(T)[5,]<qscheffe)
  
  ### Tukey
  qtuk     <-  qtukey(0.05,p,(m*n-p),lower.tail = F)/sqrt(2)  
  sT[b]    <-  sum( abs(T)< qtuk)
  Tt[b]    <-  as.numeric(abs(T)[3,]<qtuk)
  #Tt[b]   <-  as.numeric(abs(T)[1,]<qtuk)+ as.numeric(abs(T)[2,]<qtuk)+ as.numeric(abs(T)[3,]<qtuk)+ as.numeric(abs(T)[4,]<qtuk)+ as.numeric(abs(T)[5,]<qtuk)

  ###	Naive method: ignoring dependence structure
  
  Cov_bata_naive	 <- 	sii*solve(c1)
  cov_str_naive  	 <- 	t(C)%*%Cov_bata_naive %*%C
  se_str_naive 	   <- 	diag(cov_str_naive)^(-1/2)
  v_mat_n  		     <- 	diag(se_str_naive)
  corr_beta_naive  <-   v_mat_n %*% cov_str_naive %*% v_mat_n
  qu_n 		         <- 	qmvnorm(0.95, tail ="both.tails", mean = 0,  corr= corr_beta_naive)####Simultaneous quantile
  quantile_naive 	 <- 	qu_n$quantile
  T_n 		         <- 	bstr*se_str_naive
  sN[b] 	         <- 	sum(abs(T_n)<quantile_naive)
  Nn[b]            <-   as.numeric(abs(T_n)[3,]<quantile_naive)
  #Nn[b]           <-   as.numeric(abs(T_n)[1,]<quantile_naive)+ as.numeric(abs(T_n)[2,]<quantile_naive)+ as.numeric(abs(T_n)[3,]<quantile_naive)+ as.numeric(abs(T_n)[4,]<quantile_naive)+ as.numeric(abs(T_n)[5,]<quantile_naive)


  answ1<-c(paste("m",m,"p",p,"r",rhox),"MNQ",sM[b],"Naive", sN[b], "Bon" ,sB[b],"Sidak",sD[b],"Holm",sH[b], "Scheffe",sS[b],"Tukey", sT[b])
  write.table(answ1 ,file= paste("F://normPower/NormPow", m,p,rhox, ".txt"),append=TRUE,row.names=FALSE,col.names=FALSE,sep=" ",eol = "\n")
  
  
  answ2<-  c(paste("m",m,"p",p,"r",rhox),"MNQ",Mm[b],"Naive", Nn[b], "Bon" ,Bb[b],"Sidak",Dd[b],"Holm",Hh[b], "Scheffe",Ss[b],"Tukey", Tt[b])
  write.table(answ2 ,file=paste("F://normPower/NormPow4", m,p,rhox,".txt"),append=TRUE,row.names=FALSE,col.names=FALSE,sep=" ",eol = "\n")
  
  print(b)
}  


